﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WinGridContextMenu
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("id", typeof(int));
            table.Columns.Add("Image", typeof(Image));
            table.Columns.Add("Text", typeof(string)).DefaultValue = "Text";
            table.Rows.Add(0, Image.FromFile("..//..//bike.jpg"));
            table.Rows.Add(1, Image.FromFile("..//..//motorcycle.jpg"));
            table.Rows.Add(2, Image.FromFile("..//..//Car.jpg"));
            table.Rows.Add(0, Image.FromFile("..//..//bike.jpg"));
            table.Rows.Add(1, Image.FromFile("..//..//motorcycle.jpg"));
            table.Rows.Add(2, Image.FromFile("..//..//Car.jpg"));
            ultraGrid1.DataSource = table;

            contextMenuStrip1.Items["cutToolStripMenuItem"].Image = Image.FromFile("..//..//Cut.jpg");
            contextMenuStrip1.Items["copyToolStripMenuItem"].Image = Image.FromFile("..//..//Copy.jpg");
            contextMenuStrip1.Items["pasteToolStripMenuItem"].Image = Image.FromFile("..//..//Paste.jpg");
 
        }

        private void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                UltraGridCell cell = GetCell(ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(ultraGrid1.PointToClient(Cursor.Position)));
                if (cell != null && cell.Column.DataType == typeof(Image))
                {
                    contextMenuStrip1.Items["cutToolStripMenuItem"].Tag = cell;
                    contextMenuStrip1.Items["copyToolStripMenuItem"].Tag = cell;
                    contextMenuStrip1.Items["pasteToolStripMenuItem"].Tag = cell;
                    contextMenuStrip1.Show(ultraGrid1, ultraGrid1.PointToClient(Cursor.Position));
                }
            }
        }

        private UltraGridCell GetCell(UIElement element)
        {
            if (element == null)
                return null;
            if (element is CellUIElement)
                return ((CellUIElement)element).HasCell ? ((CellUIElement)element).Cell : null;
            else
                return GetCell(element.Parent);
        }


        private void cutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CutCopyPaste(sender);
        }

        private void CutCopyPaste(object sender)
        {
            ToolStripDropDownItem item = sender as ToolStripDropDownItem;
            if (item == null)
                return;
            UltraGridCell cell = item.Tag as UltraGridCell;
            if (cell == null)
                return;
            switch (item.Name)
            {
                case "cutToolStripMenuItem":
                    Clipboard.Clear();
                    Clipboard.SetImage(cell.Value as Image);
                    cell.Value = System.DBNull.Value;
                    break;
                case "copyToolStripMenuItem":
                    Clipboard.Clear();
                    Clipboard.SetImage(cell.Value as Image);
                    break;
                case "pasteToolStripMenuItem":
                    if (Clipboard.ContainsImage())
                    {
                        cell.Value = Clipboard.GetImage();
                    }
                    break;
            }
        }

        private void copyToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            CutCopyPaste(sender);
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CutCopyPaste(sender);
        }
    }
}
